<?php
// Add the administrative settings to the "Settings" menu.
function f2api_AdminPages() {
	if ( function_exists( 'add_submenu_page' ) ) {
		$plugin_page = add_options_page( 'FourSquareAPI', 'FourSquareAPI', 'manage_options', 'FourSquareAPI.php', 'f2api_show_admin_page' );
		add_action( 'admin_head-'. $plugin_page, 'f2api_AdminStyles' );
	}
}

function f2api_AdminStyles() {
	if ( $_GET['page'] == "FourSquareAPI.php" ) {
		if ( function_exists( 'wp_enqueue_style' ) ) {
			wp_enqueue_style( 'FourSquareAPI', get_bloginfo( 'wpurl' ) . '/wp-content/plugins/foursquareapi/css/FourSquareAPI.css', array(), false, 'all' );
		}
	}
}

// Include the Manager page
function f2api_show_admin_page() {
	if ( file_exists ( dirname(__FILE__).'/FourSquareAPI.admin.php' )) {
		include( dirname(__FILE__).'/FourSquareAPI.admin.php' );
	} else {
		_e( '<p>Couldn\'t locate ' . dirname(__FILE__) . '/FourSquareAPI.admin.php.</p>', 'FourSquareAPI' );
	}
}

function f2api_widget_init() {
	$f2api_latest_checkins_widget_options = array( 'classname' => 'f2api_widget_latest_checkins', 'description' => __( 'Display latest FourSquareAPI checkins' ) );
	wp_register_sidebar_widget( 'f2api_widget_latest_checkins', __( 'FourSquareAPI Latest Checkins' ), 'f2api_show_latest_checkins_widget', $f2api_latest_checkins_widget_options );
	wp_register_widget_control( 'f2api_widget_latest_checkins', __( 'FourSquareAPI Latest Checkins' ), 'f2api_show_latest_checkins_widget_control' );
	$f2api_badges_widget_options = array( 'classname' => 'f2api_widget_badges', 'description' => __( 'Display FourSquareAPI badges' ) );
	wp_register_sidebar_widget( 'f2api_widget_badges', __( 'FourSquareAPI Badges' ), 'f2api_show_badges_widget', $f2api_badges_widget_options );
	wp_register_widget_control( 'f2api_widget_badges', __( 'FourSquareAPI Badges' ), 'f2api_show_badges_widget_control' );
}

function f2api_show_latest_checkins_widget( $args ) {
	extract( $args );
	$f2api_latest_checkins_widget_title = get_option( 'f2api_latest_checkins_widget_title' );
	echo $before_widget;
	echo $before_title . $f2api_latest_checkins_widget_title . $after_title;
	echo f2api_latest_checkins_widget();
	echo $after_widget;
}

function f2api_show_badges_widget( $args ) {
	extract( $args );
	$f2api_badges_widget_title = get_option( 'f2api_badges_widget_title' );
	echo $before_widget;
	echo $before_title . $f2api_badges_widget_title . $after_title;
	echo f2api_badges_widget();
	echo $after_widget;
}

function f2api_show_latest_checkins_widget_control() {
	if ( isset( $_POST['info_update'] ) ) {
		update_option( 'f2api_latest_checkins_widget_title', (string)$_POST['f2api_latest_checkins_widget_title'] );
		update_option( 'f2api_latest_checkins_widget_byline', (string)$_POST['f2api_latest_checkins_widget_byline'] );
		update_option( 'f2api_latest_checkins_icon', intval( $_POST['f2api_latest_checkins_icon'] ) );
		update_option( 'f2api_latest_checkins_mayor', intval( $_POST['f2api_latest_checkins_mayor'] ) );
		update_option( 'f2api_latest_checkins_timestamp', intval( $_POST['f2api_latest_checkins_timestamp'] ) );
		update_option( 'f2api_latest_checkins_count', intval( $_POST['f2api_latest_checkins_count'] ) );
		update_option( 'f2api_latest_checkins_show_map', intval( $_POST['f2api_latest_checkins_show_map'] ) );
		update_option( 'f2api_latest_checkins_map_zoom', intval( $_POST['f2api_latest_checkins_map_zoom'] ) );
		update_option( 'f2api_latest_checkins_show_link', intval( $_POST['f2api_latest_checkins_show_link'] ) );
		update_option( 'f2api_latest_checkins_map_width', (string)$_POST['f2api_latest_checkins_map_width'] );
		update_option( 'f2api_latest_checkins_map_height', (string)$_POST['f2api_latest_checkins_map_height'] );
		update_option( 'f2api_latest_checkins_stats', intval( $_POST['f2api_latest_checkins_stats'] ) );
		update_option( 'f2api_latest_checkins_cache_mins', intval( $_POST['f2api_latest_checkins_cache_mins'] ) );
	}
	?>
	<input type="hidden" name="info_update" value="true">
	<p>
		<label for="f2api_latest_checkins_widget_title">Widget Title:</label>
		<input class="widefat" name="f2api_latest_checkins_widget_title" id="f2api_latest_checkins_widget_title" type="text" value="<?php echo get_option( 'f2api_latest_checkins_widget_title' ); ?>" />
	</p>
	<p>
		<label for="f2api_latest_checkins_widget_byline">Widget Byline:</label>
		<input class="widefat" name="f2api_latest_checkins_widget_byline" id="f2api_latest_checkins_widget_byline" type="text" value="<?php echo get_option( 'f2api_latest_checkins_widget_byline' ); ?>" />
	</p>
	<p>
		<label for="f2api_latest_checkins_icon">Show Icons:</label>
		<input type="checkbox" name="f2api_latest_checkins_icon" value="1" <?php if ( get_option( 'f2api_latest_checkins_icon' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_latest_checkins_mayor">Show Mayorships:</label>
		<input type="checkbox" name="f2api_latest_checkins_mayor" value="1" <?php if ( get_option( 'f2api_latest_checkins_mayor' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_latest_checkins_timestamp">Show Timestamps:</label>
		<input type="checkbox" name="f2api_latest_checkins_timestamp" value="1" <?php if ( get_option( 'f2api_latest_checkins_timestamp' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_latest_checkins_stats">Show Venue Stats:</label>
		<input type="checkbox" name="f2api_latest_checkins_stats" value="1" <?php if ( get_option( 'f2api_latest_checkins_stats' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_latest_checkins_show_map">Show Map:</label>
		<input type="checkbox" name="f2api_latest_checkins_show_map" value="1" <?php if ( get_option( 'f2api_latest_checkins_show_map' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_latest_checkins_map_zoom">Map Zoom: (try 16 to start with)</label>
		<input class="widefat" name="f2api_latest_checkins_map_zoom" type="text" value="<?php _e( get_option( 'f2api_latest_checkins_map_zoom' ) ); ?>" />
	</p>
	<p>
		<label for="f2api_latest_checkins_map_width">Map Width: (include px or %)</label>
		<input class="widefat" name="f2api_latest_checkins_map_width" type="text" value="<?php _e( get_option( 'f2api_latest_checkins_map_width' ) ); ?>" />
	</p>
	<p>
		<label for="f2api_latest_checkins_map_height">Map Height: (include px or %)</label>
		<input class="widefat" name="f2api_latest_checkins_map_height" type="text" value="<?php _e( get_option( 'f2api_latest_checkins_map_height' ) ); ?>" />
	</p>
	<p>
		<label for="f2api_latest_checkins_count">Number of checkins to show:</label>
		<select name="f2api_latest_checkins_count" id="f2api_latest_checkins_count">
			<option value="1"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 1 ) _e( ' selected' ); ?>>1</option>
			<option value="2"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 2 ) _e( ' selected' ); ?>>2</option>
			<option value="3"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 3 ) _e( ' selected' ); ?>>3</option>
			<option value="4"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 4 ) _e( ' selected' ); ?>>4</option>
			<option value="5"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 5 ) _e( ' selected' ); ?>>5</option>
			<option value="6"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 6 ) _e( ' selected' ); ?>>6</option>
			<option value="7"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 7 ) _e( ' selected' ); ?>>7</option>
			<option value="8"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 8 ) _e( ' selected' ); ?>>8</option>
			<option value="9"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 9 ) _e( ' selected' ); ?>>9</option>
			<option value="10"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 10 ) _e( ' selected' ); ?>>10</option>
			<option value="11"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 11 ) _e( ' selected' ); ?>>11</option>
			<option value="12"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 12 ) _e( ' selected' ); ?>>12</option>
			<option value="13"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 13 ) _e( ' selected' ); ?>>13</option>
			<option value="14"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 14 ) _e( ' selected' ); ?>>14</option>
			<option value="15"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 15 ) _e( ' selected' ); ?>>15</option>
			<option value="16"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 16 ) _e( ' selected' ); ?>>16</option>
			<option value="17"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 17 ) _e( ' selected' ); ?>>17</option>
			<option value="18"<?php if ( get_option( 'f2api_latest_checkins_count' ) == 18 ) _e( ' selected' ); ?>>18</option>
		</select>
	</p>
	<p>
		<label for="f2api_latest_checkins_cache_mins">Cache results:</label>
		<select name="f2api_latest_checkins_cache_mins" id="f2api_latest_checkins_cache_mins">
			<option value="0"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 0 ) _e( ' selected' ); ?>>never</option>
			<option value="1"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 1 ) _e( ' selected' ); ?>>for 1 minute</option>
			<option value="2"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 2 ) _e( ' selected' ); ?>>for 2 minutes</option>
			<option value="3"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 3 ) _e( ' selected' ); ?>>for 3 minutes</option>
			<option value="4"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 4 ) _e( ' selected' ); ?>>for 4 minutes</option>
			<option value="5"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 5 ) _e( ' selected' ); ?>>for 5 minutes</option>
			<option value="6"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 6 ) _e( ' selected' ); ?>>for 6 minutes</option>
			<option value="7"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 7 ) _e( ' selected' ); ?>>for 7 minutes</option>
			<option value="8"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 8 ) _e( ' selected' ); ?>>for 8 minutes</option>
			<option value="9"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 9 ) _e( ' selected' ); ?>>for 9 minutes</option>
			<option value="10"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 10 ) _e( ' selected' ); ?>>for 10 minutes</option>
			<option value="11"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 11 ) _e( ' selected' ); ?>>for 11 minutes</option>
			<option value="12"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 12 ) _e( ' selected' ); ?>>for 12 minutes</option>
			<option value="13"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 13 ) _e( ' selected' ); ?>>for 13 minutes</option>
			<option value="14"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 14 ) _e( ' selected' ); ?>>for 14 minutes</option>
			<option value="15"<?php if ( get_option( 'f2api_latest_checkins_cache_mins' ) == 15 ) _e( ' selected' ); ?>>for 15 minutes</option>
		</select>
	</p>
	<p>
		<label for="f2api_latest_checkins_link">Show Link to Plugin:</label>
		<input type="checkbox" name="f2api_latest_checkins_show_link" value="1" <?php if ( get_option( 'f2api_latest_checkins_show_link' ) ) _e( 'checked ' ); ?>/>
	</p>
	<?php
}

function f2api_show_badges_widget_control() {
	if ( isset( $_POST['info_update'] ) ) {
		update_option( 'f2api_badges_widget_title', (string)$_POST['f2api_badges_widget_title'] );
		update_option( 'f2api_badges_widget_byline', (string)$_POST['f2api_badges_widget_byline'] );
		update_option( 'f2api_badges_cache_mins', intval( $_POST['f2api_badges_cache_mins'] ) );
//		update_option( 'f2api_badges_max', intval( $_POST['f2api_badges_max'] ) );
		update_option( 'f2api_badges_show_map', intval( $_POST['f2api_badges_show_map'] ) );
		update_option( 'f2api_badges_map_height', (string)$_POST['f2api_badges_map_height'] );
		update_option( 'f2api_badges_map_width', (string)$_POST['f2api_badges_map_width'] );
		update_option( 'f2api_badges_map_zoom', intval( $_POST['f2api_badges_map_zoom'] ) );
		update_option( 'f2api_badges_show_icon', intval( $_POST['f2api_badges_show_icon'] ) );
		update_option( 'f2api_badges_icon_size', intval( $_POST['f2api_badges_icon_size'] ) );
		update_option( 'f2api_badges_show_description', intval( $_POST['f2api_badges_show_description'] ) );
		update_option( 'f2api_badges_show_venue', intval( $_POST['f2api_badges_show_venue'] ) );
		update_option( 'f2api_badges_show_timestamp', intval( $_POST['f2api_badges_show_timestamp'] ) );
		update_option( 'f2api_badges_show_stats', intval( $_POST['f2api_badges_show_stats'] ) );
		update_option( 'f2api_badges_show_link', intval( $_POST['f2api_badges_show_link'] ) );
	}
	?>
	<input type="hidden" name="info_update" value="true">
	<p>
		<label for="f2api_badges_widget_title">Widget Title:</label>
		<input class="widefat" name="f2api_badges_widget_title" id="f2api_badges_widget_title" type="text" value="<?php echo get_option( 'f2api_badges_widget_title' ); ?>" />
	</p>
	<p>
		<label for="f2api_badges_widget_byline">Widget Byline:</label>
		<input class="widefat" name="f2api_badges_widget_byline" id="f2api_badges_widget_byline" type="text" value="<?php echo get_option( 'f2api_badges_widget_byline' ); ?>" />
	</p>
<!--
	<p>
		<label for="f2api_badges_max">Maximum Badges: (0 for all)</label>
		<input class="widefat" name="f2api_badges_max" type="text" value="<?php _e( get_option( 'f2api_badges_max' ) ); ?>" />
	</p>
-->
	<p>
		<label for="f2api_badges_show_icon">Show Icons:</label>
		<input type="checkbox" name="f2api_badges_show_icon" value="1" <?php if ( get_option( 'f2api_badges_show_icon' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_badges_icon_size">Icon Size:</label>
		<select name="f2api_badges_icon_size" id="f2api_badges_icon_size">
			<option value="57"<?php if ( get_option( 'f2api_badges_icon_size' ) == 57 ) _e( ' selected' ); ?>>57px</option>
			<option value="114"<?php if ( get_option( 'f2api_badges_icon_size' ) == 114 ) _e( ' selected' ); ?>>114px</option>
			<option value="200"<?php if ( get_option( 'f2api_badges_icon_size' ) == 200 ) _e( ' selected' ); ?>>200px</option>
			<option value="300"<?php if ( get_option( 'f2api_badges_icon_size' ) == 300 ) _e( ' selected' ); ?>>300px</option>
			<option value="400"<?php if ( get_option( 'f2api_badges_icon_size' ) == 400 ) _e( ' selected' ); ?>>400px</option>
		</select>
	</p>
	<p>
		<label for="f2api_badges_show_description">Show Descriptions:</label>
		<input type="checkbox" name="f2api_badges_show_description" value="1" <?php if ( get_option( 'f2api_badges_show_description' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_badges_show_venue">Show Venues:</label>
		<input type="checkbox" name="f2api_badges_show_venue" value="1" <?php if ( get_option( 'f2api_badges_show_venue' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_badges_show_timestamp">Show Timestamp:</label>
		<input type="checkbox" name="f2api_badges_show_timestamp" value="1" <?php if ( get_option( 'f2api_badges_show_timestamp' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_badges_show_stats">Show Venue Stats:</label>
		<input type="checkbox" name="f2api_badges_show_stats" value="1" <?php if ( get_option( 'f2api_badges_show_stats' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_badges_show_map">Show Map:</label>
		<input type="checkbox" name="f2api_badges_show_map" value="1" <?php if ( get_option( 'f2api_badges_show_map' ) ) _e( 'checked ' ); ?>/>
	</p>
	<p>
		<label for="f2api_badges_map_zoom">Map Zoom: (try 16 to start with)</label>
		<input class="widefat" name="f2api_badges_map_zoom" type="text" value="<?php _e( get_option( 'f2api_badges_map_zoom' ) ); ?>" />
	</p>
	<p>
		<label for="f2api_badges_map_width">Map Width: (include px or %)</label>
		<input class="widefat" name="f2api_badges_map_width" type="text" value="<?php _e( get_option( 'f2api_badges_map_width' ) ); ?>" />
	</p>
	<p>
		<label for="f2api_badges_map_height">Map Height: (include px or %)</label>
		<input class="widefat" name="f2api_badges_map_height" type="text" value="<?php _e( get_option( 'f2api_badges_map_height' ) ); ?>" />
	</p>
	<p>
		<label for="f2api_badges_cache_mins">Cache results:</label>
		<select name="f2api_badges_cache_mins" id="f2api_badges_cache_mins">
			<option value="0"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 0 ) _e( ' selected' ); ?>>never</option>
			<option value="1"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 1 ) _e( ' selected' ); ?>>for 1 minute</option>
			<option value="2"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 2 ) _e( ' selected' ); ?>>for 2 minutes</option>
			<option value="3"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 3 ) _e( ' selected' ); ?>>for 3 minutes</option>
			<option value="4"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 4 ) _e( ' selected' ); ?>>for 4 minutes</option>
			<option value="5"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 5 ) _e( ' selected' ); ?>>for 5 minutes</option>
			<option value="6"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 6 ) _e( ' selected' ); ?>>for 6 minutes</option>
			<option value="7"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 7 ) _e( ' selected' ); ?>>for 7 minutes</option>
			<option value="8"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 8 ) _e( ' selected' ); ?>>for 8 minutes</option>
			<option value="9"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 9 ) _e( ' selected' ); ?>>for 9 minutes</option>
			<option value="10"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 10 ) _e( ' selected' ); ?>>for 10 minutes</option>
			<option value="11"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 11 ) _e( ' selected' ); ?>>for 11 minutes</option>
			<option value="12"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 12 ) _e( ' selected' ); ?>>for 12 minutes</option>
			<option value="13"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 13 ) _e( ' selected' ); ?>>for 13 minutes</option>
			<option value="14"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 14 ) _e( ' selected' ); ?>>for 14 minutes</option>
			<option value="15"<?php if ( get_option( 'f2api_badges_cache_mins' ) == 15 ) _e( ' selected' ); ?>>for 15 minutes</option>
		</select>
	</p>
	<p>
		<label for="f2api_badges_link">Show Link to Plugin:</label>
		<input type="checkbox" name="f2api_badges_show_link" value="1" <?php if ( get_option( 'f2api_badges_show_link' ) ) _e( 'checked ' ); ?>/>
	</p>
	<?php
}

function f2api_latest_checkins_widget() {
	global $wp_plugin_dir, $wp_plugin_url;
	$f2api_client_id = get_option( 'f2api_client_id' );
	$f2api_client_secret = get_option( 'f2api_client_secret' );
	$f2api_oauth_token = get_option( 'f2api_oauth_token' );
	$f2api_checkins_cache_time = get_option( 'f2api_checkins_cache_time' );
	$f2api_checkins_cache = get_option( 'f2api_checkins_cache' );
	$f2api_latest_checkins_widget_byline = get_option( 'f2api_latest_checkins_widget_byline' );
	$f2api_latest_checkins_count = get_option( 'f2api_latest_checkins_count' );
	$f2api_latest_checkins_timestamp = get_option( 'f2api_latest_checkins_timestamp' );
	$f2api_latest_checkins_icon = get_option( 'f2api_latest_checkins_icon' );
	$f2api_latest_checkins_show_map = get_option( 'f2api_latest_checkins_show_map' );
	$f2api_latest_checkins_map_zoom = get_option( 'f2api_latest_checkins_map_zoom' );
	$f2api_latest_checkins_map_width = get_option( 'f2api_latest_checkins_map_width' );
	$f2api_latest_checkins_map_height = get_option( 'f2api_latest_checkins_map_height' );
	$f2api_latest_checkins_mayor = get_option( 'f2api_latest_checkins_mayor' );
	$f2api_latest_checkins_stats = get_option( 'f2api_latest_checkins_stats' );
	$f2api_latest_checkins_cache_mins = get_option( 'f2api_latest_checkins_cache_mins' );
	$f2api_latest_checkins_show_link = get_option( 'f2api_latest_checkins_show_link' );
	$f2api_css_widget_latest_checkins_map = get_option( 'f2api_css_widget_latest_checkins_map' );
	$f2api_css_widget_latest_checkins = get_option( 'f2api_css_widget_latest_checkins' );
	$f2api_css_widget_latest_checkins_icon = get_option( 'f2api_css_widget_latest_checkins_icon' );
	$f2api_css_widget_latest_checkins_venue = get_option( 'f2api_css_widget_latest_checkins_venue' );
	$f2api_css_widget_latest_checkins_stats = get_option( 'f2api_css_widget_latest_checkins_stats' );
	$f2api_css_widget_latest_checkins_timestamp = get_option( 'f2api_css_widget_latest_checkins_timestamp' );
	$f2api_css_widget_latest_checkins_byline = get_option( 'f2api_css_widget_latest_checkins_byline' );
	if ( $f2api_latest_checkins_cache_mins == 0 || time() > $f2api_checkins_cache_time + ( 60 * $f2api_latest_checkins_cache_mins ) ) {
		// Load the Foursquare API library
		$foursquare = new FoursquareApi( $f2api_client_id, $f2api_client_secret );
		$foursquare->setRedirectUri( get_bloginfo( 'wpurl' ) . '/wp-content/plugins/foursquareapi/FourSquareAPI.php' );
		$foursquare->SetAccessToken( $f2api_oauth_token );
		// Prepare parameters
		$params = array( 'limit'=>$f2api_latest_checkins_count );
		// Perform a request to a public resource
		$response = $foursquare->GetPrivate( 'users/self/checkins', $params );
		$checkins = json_decode( $response );
		if ( $checkins->meta->code == 200 ) {
			$api_usage = get_option( 'f2api_latest_checkins_api_usage' );
			update_option( 'f2api_checkins_cache', $checkins );
			update_option( 'f2api_checkins_cache_time', time() );
			update_option( 'f2api_latest_checkins_api_usage', $api_usage + 1 );
		}
		else $checkins = $f2api_checkins_cache;
	}
	else $checkins = $f2api_checkins_cache;
	$i = 0;
	$html = '';
	if ( $f2api_latest_checkins_widget_byline != '' ) $html .= '<div id="f2api_latest_checkins_widget_byline"' . ( $f2api_css_widget_latest_checkins_byline != '' ? ' style="' . $f2api_css_widget_latest_checkins_byline . '"' : '' ) . '>' . $f2api_latest_checkins_widget_byline . '</div>';
	if ( $f2api_latest_checkins_show_map ) $html .= '<div id="latest_checkins_widget_map_canvas" style="width:' . $f2api_latest_checkins_map_width . '; height:' . $f2api_latest_checkins_map_height . '; ' . ($f2api_css_widget_latest_checkins_map != '' ? $f2api_css_widget_latest_checkins_map : '' ) . '"></div>';
	$html .= '<ul id="f2api_latest_checkins_widget"' . ( $f2api_css_widget_latest_checkins != '' ? ' style="' . $f2api_css_widget_latest_checkins . '"' : '' ) . '>';
	foreach ( $checkins->response->checkins->items as $checkin ) {
		if ( $i == 0 ) {
			if ( $f2api_latest_checkins_show_map ) $js = '
			<script type="text/javascript">
			var latest_checkins_latlng = new google.maps.LatLng(' . $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng . ');
			var latest_checkins_Options = {
			zoom: ' . $f2api_latest_checkins_map_zoom . ',
			center: latest_checkins_latlng,
			mapTypeId: google.maps.MapTypeId.ROADMAP
			};
			var latest_checkins = [';
		}
		if ( $f2api_latest_checkins_show_map ) {
			$mapLatLng = $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng;
			if ( !file_exists( $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->id . '.png' ) ) {
				if ( $checkin->venue->categories[0]->icon != '' ) {
//				copy( $checkin->venue->categories[0]->icon->prefix . '64' . $checkin->venue->categories[0]->icon->name, $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->name . '.png' );
					if ( copy( $checkin->venue->categories[0]->icon, $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->name . '.png' ) ) {
						$image = new Zebra_Image();
						$image->source_path = $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->name . '.png';
						$image->target_path = $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->id . '.png';
				    $image->resize(25, 25, ZEBRA_IMAGE_CROP_CENTER, -1);
						$js .= '
						["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $wp_plugin_url . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->id . '.png' . '"]';
				  }
				  else {
						$js .= '
						["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $checkin->venue->categories[0]->icon . '"]';
				  }
			  }
			}
			else {
				$js .= '
				["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $wp_plugin_url . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->id . '.png' . '"]';
			}
			$i++;
			if($i != $f2api_latest_checkins_count) $js .= ',';
		}
		$html .= '<li' . ( $f2api_latest_checkins_icon ? ( ( $checkin->isMayor && $f2api_latest_checkins_mayor ) ? ' style="min-height:64px;"' : ' style="min-height:32px;"' ) : '' ) . '>';
		if ( $f2api_latest_checkins_icon ) {
			$html .= '<div class="f2api_latest_checkins_widget_icon"' . ( $f2api_css_widget_latest_checkins_icon != '' ? ' style="' . $f2api_css_widget_latest_checkins_icon . '"' : '' ) . '>';
			if ( $checkin->venue->categories[0]->icon ){
//				$html .= '<img src="' . $checkin->venue->categories[0]->icon->prefix . '64' . $checkin->venue->categories[0]->icon->name . '" title="' . $checkin->venue->categories[0]->name . '" onClick="latest_checkins_map.panTo( new google.maps.LatLng(' . $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng . ') )">';
				$html .= '<img src="' . $checkin->venue->categories[0]->icon . '" title="' . $checkin->venue->categories[0]->name . '" onClick="latest_checkins_map.panTo( new google.maps.LatLng(' . $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng . ') )">';
			} else {
				$html .= '<img src="http://foursquare.com/img/categories/none.png">';
			}
			if ( $checkin->isMayor && $f2api_latest_checkins_mayor ) $html .= '<br/><img src="' . get_bloginfo('wpurl') . '/wp-content/plugins/foursquareapi/images/mayorCrown.png" width="32px" title="I am the Mayor">';
			$html .= '</div>';
		}
		$html .= '<div class="f2api_latest_checkins_widget_venue"' . ( $f2api_css_widget_latest_checkins_venue != '' ? ' style="' . $f2api_css_widget_latest_checkins_venue . '"' : '' ) . '>';
		if ( $f2api_latest_checkins_timestamp ) {
			$time = $checkin->createdAt;
			if ( ( abs( time() - $time) ) < 86400 )
			$h_time = sprintf( __('%s ago'), human_time_diff( $time ) );
			else
			$h_time = date(__('Y/m/d'), $time);
			$html .= sprintf( __('%s', 'FourSquareAPI'),' <span class="f2api_latest_checkins_widget_timestamp"' . ( $f2api_css_widget_latest_checkins_timestamp != '' ? ' style="' . $f2api_css_widget_latest_checkins_timestamp . '"' : '' ) . '><abbr title="' . date(__('Y/m/d H:i:s'), $time) . '">' . $h_time . '</abbr></span>&nbsp;&raquo;&nbsp;' );
		}
		$html .= '<a href="http://foursquare.com/venue/'.$checkin->venue->id.'" target="_blank">'.$checkin->venue->name.'</a></div>';
		if ( $f2api_latest_checkins_stats ) {
			$html .= '<ul class="f2api_latest_checkins_widget_stats"' . ( $f2api_css_widget_latest_checkins_stats != '' ? ' style="' . $f2api_css_widget_latest_checkins_stats . '"' : '' ) . '>';
			$html .= '<li>Tips<br/>'.$checkin->venue->stats->tipCount.'</li>';
			$html .= '<li>People<br/>'.$checkin->venue->stats->usersCount.'</li>';
			$html .= '<li>Check-Ins<br/>'.$checkin->venue->stats->checkinsCount.'</li>';
			$html .= '<li></li>';
			$html .= '</ul>';
			$html .= '<div style="clear:both;"></div>';
		}
		$html .= '</li>';
		if($i == $f2api_latest_checkins_count) break;
	}
	$html .= '</ul>';
	if ( $f2api_latest_checkins_show_map ) $js .= '
	];
	var latest_checkins_map = new google.maps.Map(document.getElementById("latest_checkins_widget_map_canvas"), latest_checkins_Options);
	latest_checkins_Markers(latest_checkins_map, latest_checkins);
	function latest_checkins_Markers(map, locations) {
	for (var i = 0; i < locations.length; i++) {
	var latest_checkin = locations[i];
	var myLatLng = new google.maps.LatLng(latest_checkin[1], latest_checkin[2]);
	var image = new google.maps.MarkerImage(latest_checkin[4], new google.maps.Size(32, 32), new google.maps.Point(0,0), new google.maps.Point(16, 16));
	var marker = new google.maps.Marker({
	position: myLatLng,
	map: map,
	icon: image,
	title: latest_checkin[0],
	zIndex: latest_checkin[3]
	});
	}
	}
	</script>';
	if ( $f2api_latest_checkins_show_link ) $html .= '<div style="font-style:italic;font-size:0.6em;">powered by <a href="http://nzguru.net/foursquareapi-plugin-for-wordpress" target="_blank">FourSquareAPI</a></div>';
	return $html . $js;
}

function f2api_badges_widget() {
	global $wp_plugin_dir, $wp_plugin_url;
	$f2api_client_id = get_option( 'f2api_client_id' );
	$f2api_client_secret = get_option( 'f2api_client_secret' );
	$f2api_oauth_token = get_option( 'f2api_oauth_token' );
//	$f2api_badges_count = 10;//get_option( 'f2api_badges_count' );
	$f2api_badges_widget_byline = get_option( 'f2api_badges_widget_byline' );
	$f2api_badges_show_icon = get_option( 'f2api_badges_show_icon' );
	$f2api_badges_icon_size = get_option( 'f2api_badges_icon_size' );
	$f2api_badges_show_description = get_option( 'f2api_badges_show_description' );
	$f2api_badges_show_venue = get_option( 'f2api_badges_show_venue' );
	$f2api_badges_show_timestamp = get_option( 'f2api_badges_show_timestamp' );
	$f2api_badges_show_stats = get_option( 'f2api_badges_show_stats' );
	$f2api_badges_show_map = get_option( 'f2api_badges_show_map' );
	$f2api_badges_map_zoom = get_option( 'f2api_badges_map_zoom' );
	$f2api_badges_map_width = get_option( 'f2api_badges_map_width' );
	$f2api_badges_map_height = get_option( 'f2api_badges_map_height' );
	$f2api_badges_cache_mins = get_option( 'f2api_badges_cache_mins' );
	$f2api_badges_cache_time = get_option( 'f2api_badges_cache_time' );
	$f2api_badges_cache = get_option( 'f2api_badges_cache' );
	$f2api_badges_show_link = get_option( 'f2api_badges_show_link' );
	$f2api_css_widget_badges_map = get_option( 'f2api_css_widget_badges_map' );
	$f2api_css_widget_badges = get_option( 'f2api_css_widget_badges' );
	$f2api_css_widget_badges_icon = get_option( 'f2api_css_widget_badges_icon' );
	$f2api_css_widget_badges_venue = get_option( 'f2api_css_widget_badges_venue' );
	$f2api_css_widget_badges_stats = get_option( 'f2api_css_widget_badges_stats' );
	$f2api_css_widget_badges_timestamp = get_option( 'f2api_css_widget_badges_timestamp' );
	$f2api_css_widget_badges_byline = get_option( 'f2api_css_widget_badges_byline' );
	$f2api_css_widget_badges_description = get_option( 'f2api_css_widget_badges_description' );
	if ( $f2api_badges_cache_mins == 0 || time() > $f2api_badges_cache_time + ( 60 * $f2api_badges_cache_mins ) ) {
		// Load the Foursquare API library
		$foursquare = new FoursquareApi( $f2api_client_id, $f2api_client_secret );
		$foursquare->setRedirectUri( get_bloginfo( 'wpurl' ) . '/wp-content/plugins/foursquareapi/FourSquareAPI.php' );
		$foursquare->SetAccessToken( $f2api_oauth_token );
		// Prepare parameters
		$params = array();
		// Perform a request to a public resource
		$response = $foursquare->GetPrivate( 'users/self/badges', $params );
		$badges = json_decode( $response );
		if ( $badges->meta->code == 200 ) {
			$api_usage = get_option( 'f2api_badges_api_usage' );
			update_option( 'f2api_badges_cache', $badges );
			update_option( 'f2api_badges_cache_time', time() );
			update_option( 'f2api_badges_api_usage', $api_usage + 1 );
		}
		else $badges = $f2api_badges_cache;
	}
	else $badges = $f2api_badges_cache;
	$i = -1;
	$html = '';
	if ( $f2api_badges_widget_byline != '' ) $html .= '<div id="f2api_badges_widget_byline"' . ( $f2api_css_widget_badges_byline != '' ? ' style="' . $f2api_css_widget_badges_byline . '"' : '' ) . '>' . $f2api_badges_widget_byline . '</div>';
	if ( $f2api_badges_show_map ) $html .= '<div id="badges_widget_map_canvas" style="width:' . $f2api_badges_map_width . '; height:' . $f2api_badges_map_height . '; ' . ($f2api_css_widget_badges_map != '' ? $f2api_css_widget_badges_map : '' ) . '"></div>';
	if ( $f2api_badges_show_venue || $f2api_badges_show_description ) $html .= '<ul id="f2api_badges_widget"' . ( $f2api_css_widget_badges != '' ? ' style="' . $f2api_css_widget_badges . '"' : '' ) . '>';
	else $html .= '<div id="f2api_badges_widget"' . ( $f2api_css_widget_badges != '' ? ' style="' . $f2api_css_widget_badges . '"' : '' ) . '>';
	$js = '';
	$lis = '';
	foreach ( $badges->response->badges as $badge ) {
		$li = '';
		$checkin = $badge->unlocks[0]->checkins[0];
		if ( $checkin ) {
			$i++;
			if ( $f2api_badges_show_map ) {
				$mapLatLng = $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng;
				if ( !file_exists( $wp_plugin_dir . '/foursquareapi/images/mapbadge_' . $badge->badgeId . '.png' ) ) {
					if ( copy( $badge->image->prefix . $f2api_badges_icon_size . $badge->image->name, $wp_plugin_dir . '/foursquareapi/images/' . $badge->image->name ) ) {
						$image = new Zebra_Image();
						$image->source_path = $wp_plugin_dir . '/foursquareapi/images/' . $badge->image->name;
						$image->target_path = $wp_plugin_dir . '/foursquareapi/images/mapbadge_' . $badge->badgeId . '.png';
				    $image->resize(25, 25, ZEBRA_IMAGE_CROP_CENTER, -1);
						$js .= '
						["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $wp_plugin_url . '/foursquareapi/images/mapbadge_' . $badge->badgeId . '.png' . '"],';
					}
					else {
						$js .= '
						["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $badge->image->prefix . $f2api_badges_icon_size . $badge->image->name . '"],';
					}
				}
				else {
					$js .= '
					["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $wp_plugin_url . '/foursquareapi/images/mapbadge_' . $badge->badgeId . '.png' . '"],';
				}
			}
			if ( $f2api_badges_show_venue || $f2api_badges_show_description ) $li .= '<li>';
			if ( $f2api_badges_show_icon ) {
				$li .= '<div class="f2api_badges_widget_icon"' . ( $f2api_css_widget_badges_icon != '' ? ' style="' . $f2api_css_widget_badges_icon . '"' : '' ) . '>';
				if ( $badge->image ){
					$li .= '<img src="' . $badge->image->prefix . $f2api_badges_icon_size . $badge->image->name . '" title="' . $badge->name . ( $f2api_badges_show_map ? '" onClick="badges_map.panTo( new google.maps.LatLng(' . $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng . ') )"' : '"' ) . ' width="' . $f2api_badges_icon_size . 'px" height="' . $f2api_badges_icon_size . 'px">';
				} else {
					$li .= '<img src="https://foursquare.com/img/badge/24/allbadges.png" width="' . $f2api_badges_icon_size . 'px" height="' . $f2api_badges_icon_size . 'px" />';
				}
				$li .= '</div>';
			}
			if ( $f2api_badges_show_venue ) {
				$li .= '<div class="f2api_badges_widget_venue"' . ( $f2api_css_widget_badges_venue != '' ? ' style="' . $f2api_css_widget_badges_venue . '"' : '' ) . '>';
				if ( $f2api_badges_show_timestamp ) {
					$time = $checkin->createdAt;
					if ( ( abs( time() - $time) ) < 86400 )
					$h_time = sprintf( __('%s ago'), human_time_diff( $time ) );
					else
					$h_time = date(__('Y/m/d'), $time);
					$li .= sprintf( __('%s', 'FourSquareAPI'),' <span class="f2api_badges_widget_timestamp"' . ( $f2api_css_widget_badges_timestamp != '' ? ' style="' . $f2api_css_widget_badges_timestamp . '"' : '' ) . '><abbr title="' . date(__('Y/m/d H:i:s'), $time) . '">' . $h_time . '</abbr></span>&nbsp;&raquo;&nbsp;' );
				}
				$li .= $badge->name . ' unlocked at <a href="http://foursquare.com/venue/'.$checkin->venue->id.'" target="_blank">'.$checkin->venue->name.'</a></div>';
				if ( $f2api_badges_show_stats ) {
					$li .= '<ul class="f2api_badges_widget_stats"' . ( $f2api_css_widget_badges_stats != '' ? ' style="' . $f2api_css_widget_badges_stats . '"' : '' ) . '>';
					$li .= '<li>Tips<br/>'.$checkin->venue->stats->tipCount.'</li>';
					$li .= '<li>People<br/>'.$checkin->venue->stats->usersCount.'</li>';
					$li .= '<li>Check-Ins<br/>'.$checkin->venue->stats->checkinsCount.'</li>';
					$li .= '<li></li>';
					$li .= '</ul>';
					$li .= '<div style="clear:both;"></div>';
				}
			}
			if ( $f2api_badges_show_description ) {
				$li .= '<span class="f2api_badges_widget_description"' . ( $f2api_css_widget_badges_description != '' ? ' style="' . $f2api_css_widget_badges_description . '"' : '' ) . '>' . $badge->description . '</span>';
			}
			if ( $f2api_badges_show_venue || $f2api_badges_show_description ) {
				$li .= '</li>';
			}
			$lis = $li . $lis;
		}
//			if($i == $f2api_badges_count) break;
	}
	if ( $f2api_badges_show_map ) $js = '
	<script type="text/javascript">
	var badges_latlng = new google.maps.LatLng(' . $mapLatLng . ');
	var badges_Options = {
	zoom: ' . $f2api_badges_map_zoom . ',
	center: badges_latlng,
	mapTypeId: google.maps.MapTypeId.ROADMAP
	};
	var badges = [' . substr( $js, 0, -1 );
	if ( $f2api_badges_show_venue || $f2api_badges_show_description ) $html .= $lis . '</ul>';
	else $html .= $lis . '</div>';
	if ( $f2api_badges_show_map ) $js .= '
	];
	var badges_map = new google.maps.Map(document.getElementById("badges_widget_map_canvas"), badges_Options);
	badges_Markers(badges_map, badges);
	function badges_Markers(map, locations) {
	for (var i = 0; i < locations.length; i++) {
	var badge = locations[i];
	var myLatLng = new google.maps.LatLng(badge[1], badge[2]);
	var image = new google.maps.MarkerImage(badge[4], new google.maps.Size(25, 25), new google.maps.Point(0,0), new google.maps.Point(13, 13));
	var marker = new google.maps.Marker({
	position: myLatLng,
	map: map,
	icon: image,
	title: badge[0],
	zIndex: badge[3]
	});
	}
	}
	</script>';
	if ( $f2api_badges_show_link ) $html .= '<div style="clear:both;font-style:italic;font-size:0.6em;">powered by <a href="http://nzguru.net/foursquareapi-plugin-for-wordpress" target="_blank">FourSquareAPI</a></div>';
	return $html . $js;
}

function f2api_checkins_shortcode() {
	global $wp_plugin_dir, $wp_plugin_url;
	$f2api_client_id = get_option( 'f2api_client_id' );
	$f2api_client_secret = get_option( 'f2api_client_secret' );
	$f2api_oauth_token = get_option( 'f2api_oauth_token' );
	$f2api_checkins_cache_time = get_option( 'f2api_checkins_cache_time' );
	$f2api_checkins_cache = get_option( 'f2api_checkins_cache' );
	$f2api_page_checkins_count = get_option( 'f2api_page_checkins_count' );
	$f2api_page_checkins_timestamp = get_option( 'f2api_page_checkins_timestamp' );
	$f2api_page_checkins_icon = get_option( 'f2api_page_checkins_icon' );
	$f2api_page_checkins_map = get_option( 'f2api_page_checkins_map' );
	$f2api_page_checkins_map_zoom = get_option( 'f2api_page_checkins_map_zoom' );
	$f2api_page_checkins_map_width = get_option( 'f2api_page_checkins_map_width' );
	$f2api_page_checkins_map_height = get_option( 'f2api_page_checkins_map_height' );
	$f2api_page_checkins_mayor = get_option( 'f2api_page_checkins_mayor' );
	$f2api_page_checkins_stats = get_option( 'f2api_page_checkins_stats' );
	$f2api_page_checkins_cache_mins = get_option( 'f2api_page_checkins_cache_mins' );
	$f2api_page_checkins_link = get_option( 'f2api_page_checkins_link' );
	$f2api_css_page_checkins_map = get_option( 'f2api_css_page_checkins_map' );
	$f2api_css_page_checkins = get_option( 'f2api_css_page_checkins' );
	$f2api_css_page_checkins_icon = get_option( 'f2api_css_page_checkins_icon' );
	$f2api_css_page_checkins_venue = get_option( 'f2api_css_page_checkins_venue' );
	$f2api_css_page_checkins_stats = get_option( 'f2api_css_page_checkins_stats' );
	$f2api_css_page_checkins_timestamp = get_option( 'f2api_css_page_checkins_timestamp' );
	if ( $f2api_page_checkins_cache_mins == 0 || time() > $f2api_checkins_cache_time + ( 60 * $f2api_page_checkins_cache_mins ) ) {
		// Load the Foursquare API library
		$foursquare = new FoursquareApi( $f2api_client_id, $f2api_client_secret );
		$foursquare->setRedirectUri( get_bloginfo( 'wpurl' ) . '/wp-content/plugins/foursquareapi/FourSquareAPI.php' );
		$foursquare->SetAccessToken( $f2api_oauth_token );
		// Prepare parameters
		$params = array( 'limit'=>250 );
		// Perform a request to a public resource
		$response = $foursquare->GetPrivate( 'users/self/checkins', $params );
		$checkins = json_decode( $response );
		if ( $checkins->meta->code == 200 ) {
			$api_usage = get_option( 'f2api_page_checkins_api_usage' );
			update_option( 'f2api_checkins_cache', $checkins );
			update_option( 'f2api_checkins_cache_time', time() );
			update_option( 'f2api_page_checkins_api_usage', $api_usage + 1 );
		}
		else $checkins = $f2api_checkins_cache;
	}
	else $checkins = $f2api_checkins_cache;
	$i = 0;
	$html = '';
//	if ( $f2api_page_checkins_widget_byline != '' ) $html .= '<div id="f2api_latest_checkins_widget_byline"' . ( $f2api_css_widget_latest_checkins_byline != '' ? ' style="' . $f2api_css_widget_latest_checkins_byline . '"' : '' ) . '>' . $f2api_latest_checkins_widget_byline . '</div>';
	if ( $f2api_page_checkins_map ) $html .= '<div id="page_checkins_map_canvas" style="width:' . $f2api_page_checkins_map_width . '; height:' . $f2api_page_checkins_map_height . '; ' . ($f2api_css_page_checkins_map != '' ? $f2api_css_page_checkins_map : '' ) . '"></div>';
	$html .= '<ul id="f2api_latest_checkins_page"' . ( $f2api_css_page_checkins != '' ? ' style="' . $f2api_css_page_checkins . '"' : '' ) . '>';
	foreach ( $checkins->response->checkins->items as $checkin ) {
		if ( $i == 0 ) {
			if ( $f2api_page_checkins_map ) $js = '
			<script type="text/javascript">
			var page_checkins_latlng = new google.maps.LatLng(' . $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng . ');
			var page_checkins_Options = {
			zoom: ' . $f2api_page_checkins_map_zoom . ',
			center: page_checkins_latlng,
			mapTypeId: google.maps.MapTypeId.ROADMAP
			};
			var page_checkins = [';
		}
		if ( $f2api_page_checkins_map ) {
			$mapLatLng = $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng;
			if ( !file_exists( $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->id . '.png' ) ) {
				if ( $checkin->venue->categories[0]->icon != '' ) {
//				copy( $checkin->venue->categories[0]->icon->prefix . '64' . $checkin->venue->categories[0]->icon->name, $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->name . '.png' );
					if ( copy( $checkin->venue->categories[0]->icon, $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->name . '.png' ) ) {
						$image = new Zebra_Image();
						$image->source_path = $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->name . '.png';
						$image->target_path = $wp_plugin_dir . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->id . '.png';
				    $image->resize(25, 25, ZEBRA_IMAGE_CROP_CENTER, -1);
						$js .= '
						["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $wp_plugin_url . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->id . '.png' . '"]';
				  }
				  else {
						$js .= '
						["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $checkin->venue->categories[0]->icon . '"]';
				  }
			  }
			}
			else {
				$js .= '
				["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $wp_plugin_url . '/foursquareapi/images/cat_' . $checkin->venue->categories[0]->id . '.png' . '"]';
			}
			$i++;
			if($i != $f2api_page_checkins_count) $js .= ',';
		}
		$html .= '<li' . ( $f2api_page_checkins_icon ? ' style="min-height:32px;"' : '' ) . '>';
		if ( $f2api_page_checkins_icon ) {
			$html .= '<div class="f2api_page_checkins_icon"' . ( $f2api_css_page_checkins_icon != '' ? ' style="' . $f2api_css_page_checkins_icon . '"' : '' ) . '>';
			if ( $checkin->isMayor && $f2api_page_checkins_mayor ) $html .= '<img src="' . get_bloginfo('wpurl') . '/wp-content/plugins/foursquareapi/images/mayorCrown.png" width="32px" title="I am the Mayor">';
			if ( $checkin->venue->categories[0]->icon ){
//				$html .= '<img src="' . $checkin->venue->categories[0]->icon->prefix . '64' . $checkin->venue->categories[0]->icon->name . '" title="' . $checkin->venue->categories[0]->name . '" onClick="latest_checkins_map.panTo( new google.maps.LatLng(' . $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng . ') )">';
				$html .= '<img src="' . $checkin->venue->categories[0]->icon . '" title="' . $checkin->venue->categories[0]->name . '" onClick="page_checkins_map.panTo( new google.maps.LatLng(' . $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng . ') )">';
			} else {
				$html .= '<img src="http://foursquare.com/img/categories/none.png">';
			}
			$html .= '</div>';
		}
		$html .= '<div class="f2api_page_checkins_venue"' . ( $f2api_css_page_checkins_venue != '' ? ' style="' . $f2api_css_page_checkins_venue . '"' : '' ) . '>';
		if ( $f2api_page_checkins_timestamp ) {
			$time = $checkin->createdAt;
			if ( ( abs( time() - $time) ) < 86400 )
			$h_time = sprintf( __('%s ago'), human_time_diff( $time ) );
			else
			$h_time = date(__('Y/m/d'), $time);
			$html .= sprintf( __('%s', 'FourSquareAPI'),' <span class="f2api_latest_checkins_widget_timestamp"' . ( $f2api_css_page_checkins_timestamp != '' ? ' style="' . $f2api_css_page_checkins_timestamp . '"' : '' ) . '><abbr title="' . date(__('Y/m/d H:i:s'), $time) . '">' . $h_time . '</abbr></span>&nbsp;&raquo;&nbsp;' );
		}
		$html .= '<a href="http://foursquare.com/venue/'.$checkin->venue->id.'" target="_blank">'.$checkin->venue->name.'</a></div>';
		if ( $f2api_page_checkins_stats ) {
			$html .= '<ul class="f2api_latest_checkins_widget_stats"' . ( $f2api_css_page_checkins_stats != '' ? ' style="' . $f2api_css_page_checkins_stats . '"' : '' ) . '>';
			$html .= '<li>Tips<br/>'.$checkin->venue->stats->tipCount.'</li>';
			$html .= '<li>People<br/>'.$checkin->venue->stats->usersCount.'</li>';
			$html .= '<li>Check-Ins<br/>'.$checkin->venue->stats->checkinsCount.'</li>';
			$html .= '<li></li>';
			$html .= '</ul>';
			$html .= '<div style="clear:both;"></div>';
		}
		$html .= '</li>';
		if ( $f2api_page_checkins_count != 0 && $i == $f2api_page_checkins_count ) break;
	}
	$html .= '</ul>';
	if ( $f2api_page_checkins_map ) $js .= '
	];
	var page_checkins_map = new google.maps.Map(document.getElementById("page_checkins_map_canvas"), page_checkins_Options);
	page_checkins_Markers(page_checkins_map, page_checkins);
	function page_checkins_Markers(map, locations) {
	for (var i = 0; i < locations.length; i++) {
	var page_checkin = locations[i];
	var myLatLng = new google.maps.LatLng(page_checkin[1], page_checkin[2]);
	var image = new google.maps.MarkerImage(page_checkin[4], new google.maps.Size(32, 32), new google.maps.Point(0,0), new google.maps.Point(16, 16));
	var marker = new google.maps.Marker({
	position: myLatLng,
	map: map,
	icon: image,
	title: page_checkin[0],
	zIndex: page_checkin[3]
	});
	}
	}
	</script>';
	if ( $f2api_page_checkins_link ) $html .= '<div style="font-style:italic;font-size:0.6em;">powered by <a href="http://nzguru.net/foursquareapi-plugin-for-wordpress" target="_blank">FourSquareAPI</a></span>';
	return $html . $js;
}

function f2api_badges_shortcode() {
	global $wp_plugin_dir, $wp_plugin_url;
	$f2api_client_id = get_option( 'f2api_client_id' );
	$f2api_client_secret = get_option( 'f2api_client_secret' );
	$f2api_oauth_token = get_option( 'f2api_oauth_token' );
//	$f2api_badges_count = 10;//get_option( 'f2api_badges_count' );
//	$f2api_badges_byline = get_option( 'f2api_badges_widget_byline' );
	$f2api_page_badges_icon = get_option( 'f2api_page_badges_icon' );
	$f2api_page_badges_icon_size = get_option( 'f2api_page_badges_icon_size' );
	$f2api_page_badges_description = get_option( 'f2api_page_badges_description' );
	$f2api_page_badges_venue = get_option( 'f2api_page_badges_venue' );
	$f2api_page_badges_timestamp = get_option( 'f2api_page_badges_timestamp' );
	$f2api_page_badges_stats = get_option( 'f2api_page_badges_stats' );
	$f2api_page_badges_map = get_option( 'f2api_page_badges_map' );
	$f2api_page_badges_map_zoom = get_option( 'f2api_page_badges_map_zoom' );
	$f2api_page_badges_map_width = get_option( 'f2api_page_badges_map_width' );
	$f2api_page_badges_map_height = get_option( 'f2api_page_badges_map_height' );
	$f2api_page_badges_cache_mins = get_option( 'f2api_page_badges_cache_mins' );
	$f2api_page_badges_cache_time = get_option( 'f2api_page_badges_cache_time' );
	$f2api_page_badges_cache = get_option( 'f2api_page_badges_cache' );
	$f2api_page_badges_link = get_option( 'f2api_page_badges_link' );
	$f2api_css_page_badges_map = get_option( 'f2api_css_page_badges_map' );
	$f2api_css_page_badges = get_option( 'f2api_css_page_badges' );
	$f2api_css_page_badges_icon = get_option( 'f2api_css_page_badges_icon' );
	$f2api_css_page_badges_venue = get_option( 'f2api_css_page_badges_venue' );
	$f2api_css_page_badges_stats = get_option( 'f2api_css_page_badges_stats' );
	$f2api_css_page_badges_timestamp = get_option( 'f2api_css_page_badges_timestamp' );
	$f2api_css_page_badges_byline = get_option( 'f2api_css_page_badges_byline' );
	$f2api_css_page_badges_description = get_option( 'f2api_css_page_badges_description' );
	if ( $f2api_page_badges_cache_mins == 0 || time() > $f2api_page_badges_cache_time + ( 60 * $f2api_page_badges_cache_mins ) ) {
		// Load the Foursquare API library
		$foursquare = new FoursquareApi( $f2api_client_id, $f2api_client_secret );
		$foursquare->setRedirectUri( get_bloginfo( 'wpurl' ) . '/wp-content/plugins/foursquareapi/FourSquareAPI.php' );
		$foursquare->SetAccessToken( $f2api_oauth_token );
		// Prepare parameters
		$params = array();
		// Perform a request to a public resource
		$response = $foursquare->GetPrivate( 'users/self/badges', $params );
		$badges = json_decode( $response );
		if ( $badges->meta->code == 200 ) {
			$api_usage = get_option( 'f2api_page_badges_api_usage' );
			update_option( 'f2api_page_badges_cache', $badges );
			update_option( 'f2api_page_badges_cache_time', time() );
			update_option( 'f2api_page_badges_api_usage', $api_usage + 1 );
		}
		else $badges = $f2api_page_badges_cache;
	}
	else $badges = $f2api_page_badges_cache;
	$i = -1;
	$html = '';
//	if ( $f2api_page_badges_byline != '' ) $html .= '<div id="f2api_badges_widget_byline"' . ( $f2api_css_widget_badges_byline != '' ? ' style="' . $f2api_css_widget_badges_byline . '"' : '' ) . '>' . $f2api_badges_widget_byline . '</div>';
	if ( $f2api_page_badges_map ) $html .= '<div id="page_badges_map_canvas" style="width:' . $f2api_page_badges_map_width . '; height:' . $f2api_page_badges_map_height . '; ' . ($f2api_css_page_badges_map != '' ? $f2api_css_page_badges_map : '' ) . '"></div>';
	if ( $f2api_page_badges_venue || $f2api_page_badges_description ) $html .= '<ul id="f2api_badges_widget"' . ( $f2api_css_page_badges != '' ? ' style="' . $f2api_css_page_badges . '"' : '' ) . '>';
	else $html .= '<div id="f2api_badges_widget"' . ( $f2api_css_page_badges != '' ? ' style="' . $f2api_css_page_badges . '"' : '' ) . '>';
	$js = '';
	$lis = '';
	foreach ( $badges->response->badges as $badge ) {
		$li = '';
		$checkin = $badge->unlocks[0]->checkins[0];
		if ( $checkin ) {
			$i++;
			if ( $f2api_page_badges_map ) {
				$mapLatLng = $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng;
				if ( !file_exists( $wp_plugin_dir . '/foursquareapi/images/mapbadge_' . $badge->badgeId . '.png' ) ) {
					if ( copy( $badge->image->prefix . $f2api_page_badges_icon_size . $badge->image->name, $wp_plugin_dir . '/foursquareapi/images/' . $badge->image->name ) ) {
						$image = new Zebra_Image();
						$image->source_path = $wp_plugin_dir . '/foursquareapi/images/' . $badge->image->name;
						$image->target_path = $wp_plugin_dir . '/foursquareapi/images/mapbadge_' . $badge->badgeId . '.png';
				    $image->resize(25, 25, ZEBRA_IMAGE_CROP_CENTER, -1);
						$js .= '
						["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $wp_plugin_url . '/foursquareapi/images/mapbadge_' . $badge->badgeId . '.png' . '"],';
					}
					else {
						$js .= '
						["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $badge->image->prefix . $f2api_page_badges_icon_size . $badge->image->name . '"],';
					}
				}
				else {
					$js .= '
					["'.$checkin->venue->name.'",' . $mapLatLng . ', ' . $i . ', "' . $wp_plugin_url . '/foursquareapi/images/mapbadge_' . $badge->badgeId . '.png' . '"],';
				}
			}
			if ( $f2api_page_badges_venue || $f2api_page_badges_description ) $li .= '<li>';
			if ( $f2api_page_badges_icon ) {
				$li .= '<div class="f2api_page_badges_icon"' . ( $f2api_css_page_badges_icon != '' ? ' style="' . $f2api_css_page_badges_icon . '"' : '' ) . '>';
				if ( $badge->image ){
					$li .= '<img src="' . $badge->image->prefix . $f2api_page_badges_icon_size . $badge->image->name . '" title="' . $badge->name . ( $f2api_page_badges_map ? '" onClick="page_badges_map.panTo( new google.maps.LatLng(' . $checkin->venue->location->lat . ', ' . $checkin->venue->location->lng . ') )"' : '"' ) . ' width="' . $f2api_page_badges_icon_size . 'px" height="' . $f2api_page_badges_icon_size . 'px">';
				} else {
					$li .= '<img src="https://foursquare.com/img/badge/24/allbadges.png" width="' . $f2api_page_badges_icon_size . 'px" height="' . $f2api_page_badges_icon_size . 'px" />';
				}
				$li .= '</div>';
			}
			if ( $f2api_page_badges_venue ) {
				$li .= '<div class="f2api_page_badges_venue"' . ( $f2api_css_page_badges_venue != '' ? ' style="' . $f2api_css_page_badges_venue . '"' : '' ) . '>';
				if ( $f2api_page_badges_timestamp ) {
					$time = $checkin->createdAt;
					if ( ( abs( time() - $time) ) < 86400 )
					$h_time = sprintf( __('%s ago'), human_time_diff( $time ) );
					else
					$h_time = date(__('Y/m/d'), $time);
					$li .= sprintf( __('%s', 'FourSquareAPI'),' <span class="f2api_page_badges_timestamp"' . ( $f2api_css_page_badges_timestamp != '' ? ' style="' . $f2api_css_page_badges_timestamp . '"' : '' ) . '><abbr title="' . date(__('Y/m/d H:i:s'), $time) . '">' . $h_time . '</abbr></span>&nbsp;&raquo;&nbsp;' );
				}
				$li .= $badge->name . ' unlocked at <a href="http://foursquare.com/venue/'.$checkin->venue->id.'" target="_blank">'.$checkin->venue->name.'</a></div>';
				if ( $f2api_page_badges_stats ) {
					$li .= '<ul class="f2api_badges_widget_stats"' . ( $f2api_css_page_badges_stats != '' ? ' style="' . $f2api_css_page_badges_stats . '"' : '' ) . '>';
					$li .= '<li>Tips<br/>'.$checkin->venue->stats->tipCount.'</li>';
					$li .= '<li>People<br/>'.$checkin->venue->stats->usersCount.'</li>';
					$li .= '<li>Check-Ins<br/>'.$checkin->venue->stats->checkinsCount.'</li>';
					$li .= '<li></li>';
					$li .= '</ul>';
					$li .= '<div style="clear:both;"></div>';
				}
			}
			if ( $f2api_page_badges_description ) {
				$li .= '<p class="f2api_page_badges_description"' . ( $f2api_css_page_badges_description != '' ? ' style="' . $f2api_css_page_badges_description . '"' : '' ) . '>' . $badge->description . '</p>';
			}
			if ( $f2api_page_badges_venue || $f2api_page_badges_description ) {
				$li .= '</li>';
			}
			$lis = $li . $lis;
		}
//			if($i == $f2api_badges_count) break;
	}
	if ( $f2api_page_badges_map ) $js = '
	<script type="text/javascript">
	var page_badges_latlng = new google.maps.LatLng(' . $mapLatLng . ');
	var page_badges_Options = {
	zoom: ' . $f2api_page_badges_map_zoom . ',
	center: page_badges_latlng,
	mapTypeId: google.maps.MapTypeId.ROADMAP
	};
	var page_badges = [' . substr( $js, 0, -1 );
	if ( $f2api_page_badges_venue || $f2api_page_badges_description ) $html .= $lis . '</ul>';
	else $html .= $lis . '</div>';
	if ( $f2api_page_badges_map ) $js .= '
	];
	var page_badges_map = new google.maps.Map(document.getElementById("page_badges_map_canvas"), page_badges_Options);
	page_badges_Markers(page_badges_map, page_badges);
	function page_badges_Markers(map, locations) {
	for (var i = 0; i < locations.length; i++) {
	var page_badge = locations[i];
	var myLatLng = new google.maps.LatLng(page_badge[1], page_badge[2]);
	var image = new google.maps.MarkerImage(page_badge[4], new google.maps.Size(25, 25), new google.maps.Point(0,0), new google.maps.Point(13, 13));
	var marker = new google.maps.Marker({
	position: myLatLng,
	map: map,
	icon: image,
	title: page_badge[0],
	zIndex: page_badge[3]
	});
	}
	}
	</script>';
	if ( $f2api_page_badges_link ) $html .= '<div style="clear:both;font-style:italic;font-size:0.6em;">powered by <a href="http://nzguru.net/foursquareapi-plugin-for-wordpress" target="_blank">FourSquareAPI</a></div>';
	return $html . $js;
}

// function to test credentials
function f2api_oauth_test() {
	if ( get_option( 'f2api_oauth_token' ) != '' ) return true;
	else return false;
}

// convert credentials to md5 hash
function f2api_oauth_credentials_to_hash() {
	$hash = md5( get_option( 'f2api_client_id' ) . get_option( 'f2api_client_secret' ) );
	return $hash;
}

// response to settings updates
function f2api_update_oauth_settings() {
	switch ( $_POST['oauth_settings'] ) {
		case 'f2api_oauth_test':
			if ( !wp_verify_nonce($_POST['_wpnonce'], 'f2api_oauth_test') ) {
				wp_die( 'Oops, please try again.' );
			}
			$auth_test = false;
			if ( !empty( $_POST['f2api_client_id'] ) && !empty( $_POST['f2api_client_secret'] ) ) {
				update_option( 'f2api_client_id', trim( $_POST['f2api_client_id'] ) );
				update_option( 'f2api_client_secret', trim( $_POST['f2api_client_secret'] ) );
				$message = 'fail';
			}
/*
			if ( $message == 'fail' && ( time() < strtotime( $connection->http_header['date'] )-300 || time() > strtotime( $connection->http_header['date'] )+300 ) ) {
				$message = 'nosync';
			}
*/
			return $message;
			break;
		case 'f2api_disconnect':
			if ( !wp_verify_nonce( $_POST['_wpnonce'], 'f2api_disconnect' ) ) {
				wp_die( 'Oops, please try again.' );
			}
			update_option( 'f2api_oauth_token', '' );
			$message = 'cleared';
			return $message;
			break;
	}
}

// connect or disconnect form
function f2api_connect_oauth() {
	echo '<div class="postbox" style="width:74%;">';
	$server_time = date( DATE_COOKIE );

	$response = wp_remote_get( "https://api.foursquare.com/v2/");
	if ( is_wp_error( $response ) ) {
		$date = _e( 'There was an error querying FourSquare\'s servers.','FourSquareAPI' );
	}
	else {
		$date = date( DATE_COOKIE, strtotime( $response['headers']['date'] ) );
	}

//		<p>'.__('Your server time:','FourSquareAPI').' <code>'.$server_time.'</code><br/>'.__('FourSquare\'s current server time:').' <code>'.$date.'</code><br/>'.__( 'If these times are not within 5 minutes of each other, your server will not be able to connect to FourSquare.','FourSquareAPI').'</p>
	if ( !f2api_oauth_test() ) {
		_e( '
		<h3>'.__('Connect to foursquare&reg;','FourSquareAPI').'</h3>
		<div class="inside">
		<p>'.__('The process to set up OAuth authentication for your web site is a simple 2-steps.', 'FourSquareAPI').'</p>
		<form action="" method="post">
		<fieldset class="options">
		<h4>'.__('1. Register this site as an application on ', 'FourSquareAPI') . '<a href="https://foursquare.com/oauth/register" target="_blank">' . __('the foursquare&reg; application registration page','FourSquareAPI').'</a></h4>
		<ul>
		<li>'.__('If you\'re not currently logged in, log-in with the foursquare&reg; account which you want associated with this site' , 'FourSquareAPI').'</li>
		<li>'.__('Your Application\'s Name if for your own reference only.' , 'FourSquareAPI').'</li>
		<li>'.__('Your Application Web Site should be <strong>' .  get_bloginfo( 'url' ) . '</strong>','FourSquareAPI').'</li>
		<li>'.__('The WebSite and Callback URL should be ' , 'FourSquareAPI').'<strong>' . get_bloginfo('wpurl') . '/wp-content/plugins/foursquareapi/FourSquareAPI.php</strong></li>
		</ul>
		<p><em>'.__('Once you have registered your site as an application, you will be provided with two keys.' , 'FourSquareAPI').'</em></p>
		<h4>'.__('2. Copy and paste your Client ID and Client Secret into the fields below' , 'FourSquareAPI').'</h4>

		<p>
		<label for="f2api_client_id">' . __( 'foursquare&reg; Client ID', 'FourSquareAPI' ) . '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>
		<input type="text" size="70" name="f2api_client_id" id="f2api_client_id" value="' . esc_attr( get_option( 'f2api_client_id' ) ) . '" />
		</p>
		<p>
		<label for="f2api_client_secret">' . __( 'foursquare&reg; Client Secret', 'FourSquareAPI' ) . '</label>
		<input type="text" size="70" name="f2api_client_secret" id="f2api_client_secret" value="' . esc_attr( get_option( 'f2api_client_secret' ) ) . '" />
		</p>
		</fieldset>
		<p class="submit">
		<input type="submit" name="submit" class="button-primary" value="' . __('Save foursquare&reg; OAuth Keys', 'FourSquareAPI') . '" />&nbsp;
		' );
		if( get_option('f2api_client_id') != '' && get_option('f2api_client_secret') != '' ) {
			// Load the Foursquare API library
			$foursquare = new FoursquareAPI( get_option( 'f2api_client_id' ), get_option( 'f2api_client_secret' ), get_bloginfo('wpurl') . '/wp-content/plugins/foursquareapi/FourSquareAPI.php' );
			_e( '<a href="' . $foursquare->AuthenticationLink() . '" class="button-primary">' . __('Connect to foursquare&reg;', 'FourSquareAPI') . '</a>' );
		}
		_e( '
		</p>
		<input type="hidden" name="oauth_settings" value="f2api_oauth_test" class="hidden" style="display: none;" />
		' . wp_nonce_field( 'f2api_oauth_test', '_wpnonce', true, false ) . wp_referer_field( false ) . '
		</form>
		</div>
		' );
	}
	else {
		_e( '
		<h3>'.__('Disconnect from foursquare&reg;','FourSquareAPI').'</h3>
		<div class="inside">
		<form action="" method="post">
		<div id="f2api_authentication_display">
		<fieldset class="options">
		<p><strong class="auth_label">'.__('Client ID :', 'FourSquareAPI').'</strong> <code class="auth_code">'.get_option('f2api_client_id').'</code></p>
		<p><strong class="auth_label">'.__('Client Secret Secret :', 'FourSquareAPI').'</strong> <code class="auth_code">'.get_option('f2api_client_secret').'</code></p>
		<p><strong class="auth_label">'.__('OAuth Token :', 'FourSquareAPI').'</strong> <code class="auth_code">'.get_option('f2api_oauth_token').'</code></p>
		<p><strong class="auth_label">'.__('API Usage :', 'FourSquareAPI').'</strong>
		<ul>
		<li>Checkin Calls: Widget <code class="auth_code">' . get_option('f2api_latest_checkins_api_usage') . '</code>, Page <code class="auth_code">' . get_option('f2api_page_checkins_api_usage') . '</code></li>
		<li>Checkin Cache: last cached <code class="auth_code">'.date( 'D, d M Y H:i:s', get_option('f2api_checkins_cache_time') ).'</code></li>
		<li>Badge Calls: Widget <code class="auth_code">' . get_option('f2api_badges_api_usage') . '</code>, Page <code class="auth_code">' . get_option('f2api_page_badges_api_usage') . '</code></li>
		<li>Badge Cache: last cached <code class="auth_code">'.date( 'D, d M Y H:i:s', get_option('f2api_badges_cache_time') ).'</code></li>
		</ul>
		</p>
		</fieldset>
		<p class="submit">
		<input type="submit" name="submit" class="button-primary" value="'.__('Disconnect WordPress from FourSquare', 'FourSquareAPI').'" />
		</p>
		<input type="hidden" name="oauth_settings" value="f2api_disconnect" class="hidden" style="display: none;" />
		' . wp_nonce_field( 'f2api_disconnect', '_wpnonce', true, false ) . wp_referer_field(false) . '
		</div>
		</form>
		</div>' );
	}
	_e( '</div>' );
//		<p>' . __('Your server time:','FourSquareAPI') . ' <code>' . $server_time . '</code>.<br />' . __( 'FourSquare\'s current server time: ', 'FourSquareAPI' ) . '<code>' . $date . '</code>.</p><p> ' . __( 'If these times are not within 5 minutes of each other, your server could lose it\'s connection with FourSquare.', 'FourSquareAPI' ) . '</p>
}
?>